## tarantool 1.4.4%2b20120117

=== test/CMakeLists.txt ===
add_custom_target(test
    COMMAND python ${PROJECT_SOURCE_DIR}/test/test-run.py --builddir=${PROJECT_BINARY_DIR} --vardir=${PROJECT_BINARY_DIR}/test/var)

add_custom_target(test-force
    COMMAND python ${PROJECT_SOURCE_DIR}/test/test-run.py --builddir=${PROJECT_BINARY_DIR} --force --vardir=${PROJECT_BINARY_DIR}/test/var)

add_subdirectory(box)
add_subdirectory(connector_c)

if ("${CPACK_GENERATOR}" STREQUAL "RPM")
	install (FILES ${CMAKE_SOURCE_DIR}/test/box/tarantool.cfg
		 DESTINATION etc)
	install (FILES ${CMAKE_SOURCE_DIR}/test/box/00000000000000000001.snap
		 DESTINATION share/tarantool)
else()
	install (FILES ${CMAKE_SOURCE_DIR}/test/box/tarantool.cfg
		DESTINATION bin)
	install (FILES ${CMAKE_SOURCE_DIR}/test/box/00000000000000000001.snap
		DESTINATION bin)
endif()

=== mod/box/CMakeLists.txt ===
add_custom_command(OUTPUT ${CMAKE_SOURCE_DIR}/mod/box/memcached-grammar.m
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    COMMAND ${RAGEL} -G2 mod/box/memcached-grammar.rl
                     -o mod/box/memcached-grammar.m
    DEPENDS ${CMAKE_SOURCE_DIR}/mod/box/memcached-grammar.rl)
# Do not clean memcached-grammar.m in 'make clean'.
set_property(DIRECTORY PROPERTY CLEAN_NO_CUSTOM true)
set_property(DIRECTORY PROPERTY ADDITIONAL_MAKE_CLEAN_FILES box.lua.o)

add_custom_target(generate_memcached_grammar_m DEPENDS
    ${CMAKE_SOURCE_DIR}/mod/box/memcached-grammar.m)

# Do not try to randomly re-generate memcached-grammar.m
# after a fresh checkout/branch switch.
execute_process(COMMAND ${CMAKE_COMMAND} -E touch_nocreate
    ${CMAKE_SOURCE_DIR}/mod/box/memcached-grammar.m)

add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/box.lua.o
    COMMAND cd ${CMAKE_SOURCE_DIR}/mod/box && ${LD} -r -b binary box.lua -o ${CMAKE_CURRENT_BINARY_DIR}/box.lua.o
    DEPENDS box.lua)

set_source_files_properties(box.lua.o
    PROPERTIES EXTERNAL_OBJECT true)

set_source_files_properties(memcached-grammar.m
    PROPERTIES HEADER_FILE_ONLY true)

set_source_files_properties(memcached.m
    PROPERTIES COMPILE_FLAGS "-Wno-uninitialized")

tarantool_module("box" tuple.m index.m box.m box_lua.m memcached.m memcached-grammar.m
    box.lua.o)

## tarantool 1.4.4+20120117

=== debian/changelog ===
tarantool (1.4.4+20120117-1) unstable; urgency=low

  * Merge my changes with upstream.
  * Disable tests after building process.

 -- Dmitry E. Oboukhov <unera@debian.org>  Mon, 16 Jan 2012 22:35:44 +0400

tarantool (1.4.4+20120116-2) unstable; urgency=low

  * Add rt into Debian/kFreeBSD likdepends.

 -- Dmitry E. Oboukhov <unera@debian.org>  Mon, 16 Jan 2012 16:54:17 +0400

tarantool (1.4.4+20120116-1) unstable; urgency=low

  * New git snapshot.

 -- Dmitry E. Oboukhov <unera@debian.org>  Mon, 16 Jan 2012 11:36:19 +0400

tarantool (1.4.4+20111229+2-2) unstable; urgency=low

  * use cd instead chdir, closes: 653611;
  * use spaces instead '\t' symbol, closes: 653607;
  * use readlink instead perl command, closes: 653613.
  thanks to Norbert Kiesel <nkiesel@tbdnetworks.com> for all bugreports.
  * add libmr-tarantool-perl to 'suggests' section of debian/control.

 -- Dmitry E. Oboukhov <unera@debian.org>  Thu, 29 Dec 2011 23:21:06 +0400

tarantool (1.4.4+20111229+2-1) unstable; urgency=low

  * Debian/kFreeBSD doesn't have proctitle.

 -- Dmitry E. Oboukhov <unera@debian.org>  Thu, 29 Dec 2011 17:18:51 +0400

tarantool (1.4.4+20111229+1-1) unstable; urgency=low

  * Try to patch build-system for Debian kFreeBSD.

 -- Dmitry E. Oboukhov <unera@debian.org>  Thu, 29 Dec 2011 13:41:48 +0400

tarantool (1.4.4+20111229-1) unstable; urgency=low

  * Fix test box/args.test.

 -- Dmitry E. Oboukhov <unera@debian.org>  Thu, 29 Dec 2011 08:49:34 +0400

tarantool (1.4.4+20111228-3) unstable; urgency=low

  * kFreeBSD: uses glibc, amd64 is x86 architecture.

 -- Dmitry E. Oboukhov <unera@debian.org>  Wed, 28 Dec 2011 23:38:12 +0400

tarantool (1.4.4+20111228-2) unstable; urgency=low

  * Specify architectures.

 -- Dmitry E. Oboukhov <unera@debian.org>  Wed, 28 Dec 2011 22:40:28 +0400

tarantool (1.4.4+20111228-1) unstable; urgency=low

  * Fix build system for kFreeBSD.

 -- Dmitry E. Oboukhov <unera@debian.org>  Wed, 28 Dec 2011 21:36:33 +0400

tarantool (1.4.4-1) unstable; urgency=low

  * Init debian release, closes: #652911.

 -- Dmitry E. Oboukhov <unera@debian.org>  Sun, 18 Dec 2011 11:35:37 +0400

=== debian/rules ===
#!/usr/bin/make -f

VERSION  := $(shell dpkg-parsechangelog|grep ^Version|awk '{print $$2}')
UVERSION := $(shell echo $(VERSION)|sed 's/-[[:digit:]]\+$$//')

DEB_CMAKE_EXTRA_FLAGS := \
	-DCMAKE_BUILD_TYPE=RelWithDebugInfo \
	-DENABLE_CLIENT=true

DEB_DH_INSTALLINIT_ARGS := --name=tarantool

DEB_CMAKE_INSTALL_PREFIX := /usr
DEB_CMAKE_NORMAL_ARGS := -DCMAKE_INSTALL_PREFIX="$(DEB_CMAKE_INSTALL_PREFIX)" \
    -DCMAKE_C_FLAGS="$(CFLAGS)" \
    -DCMAKE_CXX_FLAGS="$(CXXFLAGS)" \
    -DCMAKE_SKIP_RPATH=ON \
    -DCMAKE_VERBOSE_MAKEFILE=ON \
    -DCMAKE_SYSCONF_DIR=/etc/tarantool \
    -DCMAKE_LOCALSTATE_DIR=/var
#     -DENABLE_STATIC=ON
#    -DCMAKE_C_COMPILER:FILEPATH="$(CC)" \
#    -DCMAKE_CXX_COMPILER:FILEPATH="$(CXX)" \


include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk

DEB_BUILDDIR := build-area

tarball: clean
	cd .. && tar --exclude=.git --exclude=debian \
		-czf tarantool_$(UVERSION).orig.tar.gz tarantool-$(UVERSION)

clean::
	find -type f -name \*.pyc -delete
#	find test -name \*.reject -delete

install/tarantool-dbg::
	rm -fr debian/tarantool-dbg/usr/share/doc/tarantool-dbg

install/tarantool-client-dbg::
	rm -fr debian/tarantool-client-dbg/usr/share/doc/tarantool-client-dbg

install/tarantool::
	pod2man -c 'high performance key/value storage server' \
	    debian/tarantool_box.pod > build-area/tarantool_box.1
#         make -C build-area test-force || /bin/true

install/tarantool-common::
	pod2man -c 'tarantool instances control' \
	    debian/tarantool_instance.pod > build-area/tarantool_instance.1
	install -m0755 extra/logger.pl \
	    debian/tarantool-common/usr/lib/tarantool/logger

install/tarantool-client::
	pod2man -c 'readline SQL-client for tarantool.' \
	    debian/tarantool.pod > build-area/tarantool.1

## tarantool 1.4.4+20120127

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

project(tarantool)

include(CheckLibraryExists)
include(CheckIncludeFile)
include(CheckCCompilerFlag)
include(CheckSymbolExists)
include(TestBigEndian)

find_program(ECHO echo)
find_program(XSLTPROC xsltproc)
find_program(XMLLINT xmllint)
find_program(CAT cat)
find_program(GIT git)
find_program(RAGEL ragel)
find_program(CONFETTI confetti)
find_program(LD ld)

set(luadir ${PROJECT_BINARY_DIR}/third_party/luajit/src)
link_directories(${luadir})

include(cmake/check_objective_c_compiler.cmake)

#
# This instructs the rest of the build system what product
# and what modules to produce.
#
set (TARANTOOL_PRODUCT "box")
set (TARANTOOL_MODULES "box")
set (TARANTOOL_CLIENTS "")


#
# Set default build type to Debug. This is to ease a developer's
# life. Release binaries are built by BuildBot automatically anyway.
#
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Debug CACHE STRING
        "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
        FORCE)
endif()

#
# Perform operating-system specific configuration.
#
if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
    set(TARGET_OS_LINUX 1)
#
# Enable GNU glibc extentions.
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_GNU_SOURCE")
#
# On 32-bit systems, support files larger than 2GB
# (see man page for feature_test_macros).
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_FILE_OFFSET_BITS=64")
elseif (${CMAKE_SYSTEM_NAME} STREQUAL "kFreeBSD")
    set(TARGET_OS_FREEBSD 1)
    set(TARGET_OS_DEBIAN_FREEBSD 1)
# Enable GNU glibc extentions.
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_GNU_SOURCE")
#
# On 32-bit systems, support files larger than 2GB
# (see man page for feature_test_macros).
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_FILE_OFFSET_BITS=64")
elseif (${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD")
    set(TARGET_OS_FREEBSD 1)
else()
    message (FATAL_ERROR "Unsupported platform -- ${CMAKE_SYSTEM_NAME}")
endif()

check_symbol_exists(MAP_ANON sys/mman.h HAVE_MAP_ANON)
check_symbol_exists(MAP_ANONYMOUS sys/mman.h HAVE_MAP_ANONYMOUS)

test_big_endian(HAVE_BYTE_ORDER_BIG_ENDIAN)

#
# We do not perform host-to-network byte order translation,
# and simply assume the machine is little-endian.
# We also do not bother with trying to avoid unaligned
# word access. Refuse to compile on rare hardware such as
# Sparc or Itanium.
#
if (${HAVE_BYTE_ORDER_BIG_ENDIAN} OR
    ${CMAKE_SYSTEM_PROCESSOR} STREQUAL "sparc" OR
    ${CMAKE_SYSTEM_PROCESSOR} STREQUAL "ia64" OR
    ${CMAKE_SYSTEM_PROCESSOR} MATCHES "^alpha")
    message (FATAL_ERROR "Unsupported architecture -- ${CMAKE_SYSTEM_PROCESSOR}, ")
    message (FATAL_ERROR "Tarantool currently only supports little-endian hardware")
    message (FATAL_ERROR "with unaligned word access.")
endif()

#
# Some versions of GNU libc define non-portable __libc_stack_end
# which we use to determine the end (or beginning, actually) of
# stack. Find whether or not it's present.
check_library_exists("" __libc_stack_end "" HAVE_LIBC_STACK_END)

#
# Tarantool uses 'coro' (coroutines) library # to implement
# cooperative multi-tasking. Since coro.h is included
# universally, define the underlying implementation switch
# in the top level CMakeLists.txt, to ensure a consistent
# header file layout across the entire project.
#
if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "86" OR ${CMAKE_SYSTEM_PROCESSOR} MATCHES "amd64")
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DCORO_ASM")
else()
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DCORO_SJLJ")
endif()
#
# Perform build type specific configuration.
#
set (CMAKE_C_FLAGS_DEBUG "-ggdb -O0 -fexceptions -funwind-tables")
set (CMAKE_C_FLAGS_RELWITHDEBUGINFO "-ggdb -O2 -fexceptions -funwind-tables")
set (CMAKE_C_FLAGS_RELEASE "-DNDEBUG -DNVALGRIND")

#
# Enable 'make TAGS' target.
#
add_custom_target(TAGS COMMAND ctags -R --langmap=ObjectiveC:.m -e -f TAGS
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

#
# Define TARANTOOL_VERSION -- a string constant with tarantool version.
#
set (TARANTOOL_VERSION "")
execute_process (COMMAND ${GIT} describe HEAD
    OUTPUT_VARIABLE TARANTOOL_VERSION
    OUTPUT_STRIP_TRAILING_WHITESPACE
    )
#
# Make sure the version is set even if building
# out of source.
#
set (CPACK_PACKAGE_VERSION_MAJOR "1")
set (CPACK_PACKAGE_VERSION_MINOR "4")
set (CPACK_PACKAGE_VERSION_PATCH "4")
if (TARANTOOL_VERSION STREQUAL "")
    set (TARANTOOL_VERSION
        "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
endif()


#
# Set flags for all include files: those maintained by us and
# coming from third parties.
# We must set -fno-omit-frame-pointer here, since we rely
# on frame pointer when getting a backtrace, and it must
# be used consistently across all object files.
# The same reasoning applies to -fno-stack-protector switch.
#
set (CMAKE_C_FLAGS
    "${CMAKE_C_FLAGS} -fno-omit-frame-pointer -fno-stack-protector -fexceptions -funwind-tables")
#
# Tarantool code is written in GNU C dialect.
# Additionally, compile it with more strict flags than the rest
# of the code.
#
if (${CMAKE_BUILD_TYPE} STREQUAL "None")
    set (core_cflags "-std=gnu99")
else()
    set (core_cflags "-std=gnu99 -Wall -Wextra")
    set (core_cflags "${core_cflags} -Wno-sign-compare -Wno-strict-aliasing")
endif()

# Only add -Werror if it's a debug build, done by developers.
# Community builds should not cause extra trouble.

if (${CMAKE_BUILD_TYPE} STREQUAL "Debug")
    set (core_cflags "${core_cflags} -Werror")
endif()

#
# Specify where to look for include files.
#
include_directories("${PROJECT_SOURCE_DIR}")
include_directories("${PROJECT_SOURCE_DIR}/include")
include_directories("${PROJECT_BINARY_DIR}/include")
include_directories("${PROJECT_SOURCE_DIR}/connector/c/tnt/include")
include_directories("${PROJECT_SOURCE_DIR}/connector/c/tntsql/include")
include_directories("${PROJECT_SOURCE_DIR}/connector/c/tntnet/include")

#
# Specify prefixes
#
if (NOT DEFINED CMAKE_SYSCONF_DIR)
    set (CMAKE_SYSCONF_DIR "${CMAKE_INSTALL_PREFIX}/etc")
endif()
if (NOT DEFINED CMAKE_LOCALSTATE_DIR)
    set (CMAKE_LOCALSTATE_DIR "${CMAKE_INSTALL_PREFIX}/var")
endif()

#
# Now handle all configuration options.
#
option(ENABLE_CLIENT "Enable building of console client" Off)
if (ENABLE_CLIENT)
    set (TARANTOOL_CLIENTS ${TARANTOOL_CLIENTS} "tarantool")
endif()

option(ENABLE_GCOV "Enable integration with gcov, a code coverage program" ON)
if (ENABLE_GCOV)
    check_library_exists (gcov __gcov_flush  ""  HAVE_GCOV)
    if (NOT HAVE_GCOV)
        message (FATAL_ERROR
                 "ENABLE_GCOV option requested but gcov library is not found")
    endif()
endif()

option(ENABLE_TRACE "Enable debug trace of tarantool_box execution to
a file specified in TARANTOOL_TRACE environment variable" ON)

option(ENABLE_BACKTRACE "Enable output of fiber backtrace information in 'show
fiber' administrative command. Only works on x86 architectures, if compiled
with gcc. If GNU binutils and binutils-dev libraries are installed, backtrace
is output with resolved function (symbol) names. Otherwise only frame
addresses are printed." ${CMAKE_COMPILER_IS_GNUCC})

set (HAVE_BFD False)
if (ENABLE_BACKTRACE)
    if (NOT ${CMAKE_COMPILER_IS_GNUCC} OR
        NOT (${CMAKE_SYSTEM_PROCESSOR} MATCHES "86|amd64"))
        # We only know this option to work with gcc
        # on x86 architecture.
        message (FATAL_ERROR "ENABLE_BACKTRACE option is set but the system is not x86 based (${CMAKE_SYSTEM_PROCESSOR}) or the compiler is not GNU GCC (${CMAKE_C_COMPILER}).")
    endif()
# Use GNU bfd if present.
    check_library_exists (bfd bfd_init ""  HAVE_BFD_LIB)
    check_include_file(bfd.h HAVE_BFD_H)
    if (HAVE_BFD_LIB AND HAVE_BFD_H)
        set (HAVE_BFD True)
        message (STATUS "Found GNU bfd headers and libs, enabling symbol ")
        message (STATUS "resolve in backtraces.")
    elseif (NOT HAVE_BFD_LIB)
        message (STATUS "Not found GNU bfd binaries, no symbol resolve.")
    elseif (NOT HAVE_BFD_H)
        message (STATUS "Not found GNU bfd headers, no symbol resolve. ")
        message (STATUS "Consider installing binutils-dev.")
    endif()
endif()

option(ENABLE_STATIC "Perform static linking whenever possible." OFF)

if (ENABLE_STATIC)
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -static")
endif()

# CMake believes that Objective C is a flavor of C++, not C,
# and uses g++ compiler for .m files. Since talking CMake out
# of this idea is difficult, and since gcc or g++ are only
# front-ends to the language-specific compiler specified in
# -x option, simply use CXX flags to build Objective C files.
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CMAKE_C_FLAGS}")

set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fexceptions -fobjc-exceptions")

add_subdirectory(third_party)
add_subdirectory(cfg)
add_subdirectory(connector)
add_subdirectory(core)
add_subdirectory(mod)
add_subdirectory(client)
add_subdirectory(test)
add_subdirectory(doc EXCLUDE_FROM_ALL)
add_subdirectory(extra)

install (FILES README LICENSE doc/box-protocol.txt
         DESTINATION share/doc/tarantool)

include (cmake/tarantool_cpack.cmake)
#
# Output compile-time defines into config.h. Do it at the end
# of the script to make sure all variables are set.
#
configure_file(
    "${PROJECT_SOURCE_DIR}/include/config.h.cmake"
    "${PROJECT_BINARY_DIR}/include/config.h"
    )
configure_file(
    "${PROJECT_SOURCE_DIR}/doc/tnt.ent.cmake"
    "${PROJECT_BINARY_DIR}/doc/tnt.ent"
    )

message (STATUS "")
message (STATUS "Successfully configured Tarantool infrastructure on ")
message (STATUS "${CMAKE_SYSTEM_NAME}-${CMAKE_SYSTEM_PROCESSOR}, build type '${CMAKE_BUILD_TYPE}'. ")
message (STATUS "The product you're building is \"${TARANTOOL_PRODUCT}\", enabled modules are ")
message (STATUS "${TARANTOOL_MODULES}.")
message (STATUS "Please check out CMakeCache.txt to view or modify configuration results.")
message (STATUS "")
message (STATUS "*** The following options are on in this configuration: ***")
message (STATUS "ENABLE_CLIENT: ${ENABLE_CLIENT}")
message (STATUS "ENABLE_GCOV: ${ENABLE_GCOV}")
message (STATUS "ENABLE_TRACE: ${ENABLE_TRACE}")
message (STATUS "ENABLE_BACKTRACE: ${ENABLE_BACKTRACE}")
message (STATUS "Backtrace is with symbol resolve: ${HAVE_BFD}")
message (STATUS "ENABLE_STATIC: ${ENABLE_STATIC}")
message (STATUS "")

=== cfg/CMakeLists.txt ===

# Do not clean the generated configuration files in "make clean"
#
set_property(DIRECTORY PROPERTY CLEAN_NO_CUSTOM 1)

execute_process(COMMAND ${CMAKE_COMMAND} -E touch_nocreate
    ${CMAKE_SOURCE_DIR}/cfg/prscfg.h
    ${CMAKE_SOURCE_DIR}/cfg/prscfg.c)
add_custom_command(
    OUTPUT ${CMAKE_SOURCE_DIR}/cfg/prscfg.h
           ${CMAKE_SOURCE_DIR}/cfg/prscfg.c
    COMMAND ${ECHO} '%{' > tmp.cfg
    COMMAND ${ECHO} '\#include \"cfg/warning.h\"' >> tmp.cfg
    COMMAND ${ECHO} '%}' >> tmp.cfg
    COMMAND ${CAT} ${CMAKE_SOURCE_DIR}/cfg/core_cfg.cfg_tmpl >> tmp.cfg
    COMMAND ${CONFETTI} -i tmp.cfg -n tarantool_cfg
            -H ${CMAKE_SOURCE_DIR}/cfg/prscfg.h
            -p ${CMAKE_SOURCE_DIR}/cfg/prscfg.c
    COMMAND ${CMAKE_COMMAND} -E remove tmp.cfg
    DEPENDS ${CMAKE_SOURCE_DIR}/cfg/core_cfg.cfg_tmpl
            ${CMAKE_SOURCE_DIR}/cfg/warning.h)

#
# Optionally rebuild the configuration file parsing code from
# templates.
#
macro(generate_config mod)
# Gracefully handle out-of-source builds with missing 
# 'confetti'. Make sure that generated files are older than
# their sources when configuring the project.
execute_process(COMMAND ${CMAKE_COMMAND} -E touch_nocreate
    ${CMAKE_SOURCE_DIR}/cfg/tarantool_${mod}_cfg.h
    ${CMAKE_SOURCE_DIR}/cfg/tarantool_${mod}_cfg.c)
add_custom_command(
    OUTPUT ${CMAKE_SOURCE_DIR}/cfg/tarantool_${mod}_cfg.h
           ${CMAKE_SOURCE_DIR}/cfg/tarantool_${mod}_cfg.c
    COMMAND ${ECHO} '%{' > ${mod}_tmp.cfg
    COMMAND ${ECHO} '\#include \"cfg/warning.h\"' >> ${mod}_tmp.cfg
    COMMAND ${ECHO} '\#include \"cfg/tarantool_${mod}_cfg.h\"' >> ${mod}_tmp.cfg
    COMMAND ${ECHO} '%}' >> ${mod}_tmp.cfg
    COMMAND ${CAT} ${CMAKE_SOURCE_DIR}/cfg/core_cfg.cfg_tmpl >> ${mod}_tmp.cfg
    COMMAND ${CAT} ${CMAKE_SOURCE_DIR}/mod/${mod}/${mod}_cfg.cfg_tmpl >>
            ${mod}_tmp.cfg
    COMMAND ${CONFETTI} -i ${mod}_tmp.cfg -n tarantool_cfg
            -c ${CMAKE_SOURCE_DIR}/cfg/tarantool_${mod}_cfg.c
            -h ${CMAKE_SOURCE_DIR}/cfg/tarantool_${mod}_cfg.h
    COMMAND ${CMAKE_COMMAND} -E remove ${mod}_tmp.cfg
    DEPENDS ${CMAKE_SOURCE_DIR}/cfg/core_cfg.cfg_tmpl
            ${CMAKE_SOURCE_DIR}/cfg/warning.h
            ${CMAKE_SOURCE_DIR}/mod/${mod}/${mod}_cfg.cfg_tmpl
    )
endmacro()

foreach (mod ${TARANTOOL_MODULES})
  generate_config(${mod})
  set (generated_headers ${generated_headers} 
       ${CMAKE_SOURCE_DIR}/cfg/tarantool_${mod}_cfg.h)
endforeach()

set_source_files_properties(${CMAKE_SOURCE_DIR}/cfg/prscfg.c
    PROPERTIES COMPILE_FLAGS "-Wno-unused")

add_library(cfg prscfg.c warning.c)
#
# Make sure all generated headers are built before they are used.
# This is also necessary to avoid races in parallel make,
# when tmp.cfg is corrupted by two paralled targets.
# See http://www.cmake.org/Bug/view.php?id=10082 for details.
#
add_custom_target(generate_headers
    DEPENDS ${CMAKE_SOURCE_DIR}/cfg/prscfg.h ${generated_headers})
add_dependencies(cfg generate_headers libluajit)
# Do not list this helper target among all high-level targets.
set_target_properties(generate_headers PROPERTIES EXCLUDE_FROM_ALL TRUE)

=== client/CMakeLists.txt ===

# function to build tarantool clients that use connector/c
# 
function(tarantool_client client_name)
	set (client_sources ${ARGV})
	list(REMOVE_ITEM client_sources ${client_name})
	add_executable(${client_name} ${client_sources}
		       ${CMAKE_SOURCE_DIR}/core/errcode.c)
	set (client_libs tntnet tntsql tnt)
	set_target_properties(${client_name} PROPERTIES COMPILE_FLAGS "${core_cflags}")
	target_link_libraries (${client_name} ${client_libs})
endfunction()

foreach (client ${TARANTOOL_CLIENTS})
	add_subdirectory(${client})
endforeach()

=== core/CMakeLists.txt ===
#
# libev library
#
add_library(ev tarantool_ev.c)

check_c_compiler_flag ("-Wno-unused-result" gcc_has_wno_unused_result)

if (gcc_has_wno_unused_result)
    set_source_files_properties(tarantool_ev.c
        PROPERTIES COMPILE_FLAGS "-Wno-unused-result")
endif()

if (TARGET_OS_LINUX)
#
# Enable Linux-specific event notification API (man inotify)
  set_target_properties(ev PROPERTIES COMPILE_FLAGS "-DEV_USE_INOTIFY")
elseif (TARGET_OS_FREEBSD)
#
# On FreeBSD build libev loop on top of
  set_target_properties(ev PROPERTIES COMPILE_FLAGS "-DEV_USE_KQUEUE")
endif()
#
# libev uses ceil and floor from the standard math library
#
target_link_libraries(ev m rt)

#
# Build admin.m from admin.rl, but only if admin.rl was changed.
# The same applies to memcached.m/memcached.rl.
# We track admin.m and memcached.m in revision control, and thus do not
# require engineers who do not modify .rl files to have Ragel
# installed.
#
add_custom_command(OUTPUT ${CMAKE_SOURCE_DIR}/core/admin.m
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    COMMAND ${RAGEL} -G2 core/admin.rl -o core/admin.m
    DEPENDS ${CMAKE_SOURCE_DIR}/core/admin.rl)

add_custom_target(generate_admin_m DEPENDS ${CMAKE_SOURCE_DIR}/core/admin.m)
# do not randomly try to re-generate admin.m after a fresh checkout
execute_process(COMMAND ${CMAKE_COMMAND} -E touch_nocreate
    ${CMAKE_SOURCE_DIR}/core/admin.m)

#
# Do not clean admin.m, memcached.m or other
# generated files in 'make clean' -- they are under
# revision control.
#
set_property(DIRECTORY PROPERTY CLEAN_NO_CUSTOM 1)

#
# Used by modules.
#
set (recompiled_core_sources
     ${CMAKE_SOURCE_DIR}/core/tarantool.m
     ${CMAKE_SOURCE_DIR}/core/tarantool_lua.m
     ${CMAKE_SOURCE_DIR}/core/say.m
     ${CMAKE_SOURCE_DIR}/core/assoc.m
     ${CMAKE_SOURCE_DIR}/core/admin.m
     ${CMAKE_SOURCE_DIR}/core/replication.m
     ${CMAKE_SOURCE_DIR}/core/fiber.m PARENT_SCOPE)

set (common_sources tbuf.m palloc.m util.m
    salloc.m pickle.m coro.m stat.m log_io.m cpu_feature.m
    log_io_remote.m iproto.m exception.m errcode.c latch.m)

if (ENABLE_TRACE)
  set (common_sources ${common_sources} trace.m)
endif()

add_library(core STATIC ${common_sources})
add_dependencies(core generate_headers luajit)
set_target_properties(core PROPERTIES COMPILE_FLAGS "${core_cflags}")

set (common_libraries cfg core ev coro gopt misc objc luajit)
if (TARGET_OS_LINUX)
  set (common_libraries ${common_libraries} dl)
endif()

if (TARGET_OS_DEBIAN_FREEBSD)
  set (common_libraries ${common_libraries} dl)
endif()

if (ENABLE_GCOV)
  set (common_libraries ${common_libraries} gcov)
endif()

if (ENABLE_BACKTRACE AND HAVE_BFD)
  set (common_libraries ${common_libraries} bfd)
  if (ENABLE_STATIC)
     include (FindZLIB)
     set (common_libraries ${common_libraries} ${ZLIB_LIBRARIES} iberty)
  endif()
endif()

set (common_libraries ${common_libraries} PARENT_SCOPE)

=== doc/CMakeLists.txt ===
add_subdirectory(user)
add_subdirectory(developer)

=== extra/CMakeLists.txt ===

# scripts for RPM package
#
if ("${CPACK_GENERATOR}" STREQUAL "RPM")
        # chmod +x 655
	install (FILES tarantool DESTINATION /etc/init.d
		 PERMISSIONS
		 OWNER_READ OWNER_WRITE
		 GROUP_READ GROUP_EXECUTE
		 WORLD_READ WORLD_EXECUTE)
        # chmod +x 755
        install (FILES tarantool_multi.sh DESTINATION bin
                 PERMISSIONS
                 OWNER_READ OWNER_WRITE OWNER_EXECUTE
                 GROUP_READ GROUP_EXECUTE
                 WORLD_READ WORLD_EXECUTE)
        # chmod +x 755
        install (FILES tarantool_expand.sh DESTINATION bin
                 PERMISSIONS
                 OWNER_READ OWNER_WRITE OWNER_EXECUTE
		 GROUP_READ GROUP_EXECUTE
		 WORLD_READ WORLD_EXECUTE)
endif()

=== mod/CMakeLists.txt ===

function(tarantool_module mod)
  set (module_sources ${ARGV})
  list(REMOVE_ITEM module_sources ${mod})
  set_source_files_properties(
      ${CMAKE_SOURCE_DIR}/cfg/tarantool_${mod}_cfg.c
      PROPERTIES COMPILE_FLAGS "-Wno-unused" GENERATED True)
  add_executable(tarantool_${mod}
      ${module_sources}
      ${CMAKE_SOURCE_DIR}/cfg/tarantool_${mod}_cfg.c)

  add_library(lt${mod} STATIC ${recompiled_core_sources})
  set_target_properties(lt${mod} PROPERTIES COMPILE_FLAGS
    "${core_cflags} -DTARANTOOL_CONFIG='<cfg/tarantool_${mod}_cfg.h>'")
  add_dependencies(lt${mod} generate_headers generate_admin_m)

  target_link_libraries(tarantool_${mod} lt${mod} ${common_libraries})
  set_target_properties(tarantool_${mod} PROPERTIES COMPILE_FLAGS
      "${core_cflags}")

  if (ENABLE_STATIC)
      set_target_properties(tarantool_${mod} PROPERTIES
          LINK_SEARCH_END_STATIC ON)
  endif()

  install (TARGETS tarantool_${mod} DESTINATION bin)

endfunction()

foreach (module ${TARANTOOL_MODULES})
  add_subdirectory(${module})
endforeach()

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -14,7 +14,7 @@
 		 DESTINATION share/tarantool)
 else()
 	install (FILES ${CMAKE_SOURCE_DIR}/test/box/tarantool.cfg
-		DESTINATION bin)
+		DESTINATION "${CMAKE_SYSCONF_DIR}")
 	install (FILES ${CMAKE_SOURCE_DIR}/test/box/00000000000000000001.snap
-		DESTINATION bin)
+		DESTINATION "${CMAKE_LOCALSTATE_DIR}/lib/tarantool")
 endif()

=== third_party/CMakeLists.txt ===
add_library (misc STATIC crc32.c proctitle.c qsort_arg.c)

if (NOT TARGET_OS_DEBIAN_FREEBSD) 
	if (TARGET_OS_FREEBSD)
	  set_source_files_properties(proctitle.c PROPERTIES
	       COMPILE_FLAGS "-DHAVE_SETPROCTITLE")
	endif()
endif()

add_subdirectory(coro)
add_subdirectory(gopt)

set (luajit_buildoptions BUILDMODE=static)
if (${CMAKE_BUILD_TYPE} STREQUAL "Debug")
    set (luajit_buildoptions ${luajit_buildoptions} CCOPT=-O0)
    set (luajit_buildoptions ${luajit_buildoptions} CCDEBUG=-ggdb)
    set (luajit_buildoptions ${luajit_buildoptions} XCFLAGS='-DLUA_USE_APICHECK -DLUA_USE_ASSERT')
endif()
set (luajit_buildoptions ${luajit_buildoptions} Q='')
if (${PROJECT_BINARY_DIR} STREQUAL ${PROJECT_SOURCE_DIR})
    add_custom_command(OUTPUT ${PROJECT_BINARY_DIR}/third_party/luajit/src/libluajit.a
        WORKING_DIRECTORY ${PROJECT_BINARY_DIR}/third_party/luajit
        COMMAND make clean
        COMMAND make -C src -t buildvm_x86.h buildvm_arm.h
                        buildvm_x64.h buildvm_x64win.h
        COMMAND make -C src ${luajit_buildoptions}
        DEPENDS ${CMAKE_SOURCE_DIR}/CMakeCache.txt
    )
else()
    add_custom_command(OUTPUT ${PROJECT_BINARY_DIR}/third_party/luajit
        COMMAND mkdir ${PROJECT_BINARY_DIR}/third_party/luajit
    )
    add_custom_command(OUTPUT ${PROJECT_BINARY_DIR}/third_party/luajit/src/libluajit.a
        WORKING_DIRECTORY ${PROJECT_BINARY_DIR}/third_party/luajit
        COMMAND cp -r ${PROJECT_SOURCE_DIR}/third_party/luajit/* .
        COMMAND make clean
        COMMAND make -C src -t buildvm_x86.h buildvm_arm.h
                        buildvm_x64.h buildvm_x64win.h
        COMMAND make -C src ${luajit_buildoptions}
        DEPENDS ${PROJECT_BINARY_DIR}/CMakeCache.txt ${PROJECT_BINARY_DIR}/third_party/luajit
    )
endif()
add_custom_target(libluajit
    DEPENDS ${PROJECT_BINARY_DIR}/third_party/luajit/src/libluajit.a
)

=== client/tarantool/CMakeLists.txt ===

project(tnt_cli)

# checking for readline library
#
find_library(WITH_READLINE_LIB NAMES "readline")
find_library(WITH_READLINE_HISTORY_LIB NAMES "history")

if (NOT WITH_READLINE_LIB OR NOT WITH_READLINE_HISTORY_LIB)
    message(FATAL_ERROR "readline library not found.")
endif()

set (cli_deps readline history)

# trying to resolve readline dependencies
#
find_library(WITH_NCURSES_LIB NAMES "ncurses")
if (WITH_NCURSES_LIB)
	set(cli_deps ${cli_deps} ncurses)
endif()

find_library(WITH_TERMCAP_LIB NAMES "termcap")
if (WITH_TERMCAP_LIB)
	set(cli_deps ${cli_deps} termcap)
endif()

set (cli "tarantool")
set (cli_sources tnt.c tnt_admin.c)
set (cli_libs tntnet tntsql tnt gopt ${cli_deps})

add_executable(${cli} ${cli_sources} ${CMAKE_SOURCE_DIR}/core/errcode.c)
set_target_properties(${cli} PROPERTIES COMPILE_FLAGS "${core_cflags}")
target_link_libraries (${cli} ${cli_libs})

install (TARGETS ${cli} DESTINATION bin)

=== connector/c/CMakeLists.txt ===
add_subdirectory(tnt)
add_subdirectory(tntsql)
add_subdirectory(tntnet)

=== doc/developer/CMakeLists.txt ===
add_custom_target(dev-html ALL
    COMMAND ${XSLTPROC} --nonet
        --stringparam collect.xref.targets "all"
        --xinclude -o tarantool_developer_guide.html
        ${CMAKE_SOURCE_DIR}/doc/user/tnt-html.xsl
        developer.xml)

add_custom_target(dev-check ALL
	COMMAND jing http://docbook.org/xml/5.0/rng/docbookxi.rng developer.xml
    )

=== debian/changelog ===
tarantool (1.4.4+20120127-1) unstable; urgency=low

  * Merge with upstream.
  * Package can purge not owned files, closes: #657132.

 -- Dmitry E. Oboukhov <unera@debian.org>  Fri, 27 Jan 2012 23:37:53 +0400

=== debian/control ===
Source: tarantool
Maintainer: Dmitry E. Oboukhov <unera@debian.org>
Build-Depends: cdbs, debhelper (>= 8),
 gobjc,
 cmake,
 libreadline-dev,
 python-yaml,
 python-daemon,
 python-pexpect
Section: database
Standards-Version: 3.9.2
Homepage: http://tarantool.org/
VCS-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/tarantool.git;a=summary
VCS-Git: git+ssh://git.debian.org/git/collab-maint/tarantool.git

Package: tarantool-common
Architecture: all
Priority: optional
Depends: ${misc:Depends}, adduser
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides configs and logs infrastructure for tarantool.

Package: tarantool
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}, tarantool-common
Suggests: libmr-tarantool-perl
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides tarantool server.

Package: tarantool-dbg
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: extra
Section: debug
Depends: ${shlibs:Depends}, ${misc:Depends},
     tarantool (= ${binary:Version})
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides debug symbols for all tarantool packages.

Package: tarantool-client
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides readline client for tarantool.

Package: tarantool-client-dbg
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: extra
Section: debug
Depends: ${shlibs:Depends}, ${misc:Depends},
    tarantool-client (= ${binary:Version})
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides readline client for tarantool.
